<?php

/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 *
 * $Id: infoPackage.inc.php 6684 2010-04-22 11:43:16Z cdelfosse $
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC.  If not, see <http://www.gnu.org/licenses/>.
 */

require_once("modules/ppolicy/includes/ppolicy-xmlrpc.php");
require_once("modules/ppolicy/includes/ppolicy.inc.php");

/**
 * ppolicy module declaration
 */


$mod = new Module("ppolicy");
$mod->setVersion("3.0.0");
$mod->setRevision('$Rev: 6684 $');
$mod->setDescription(_T("Password Policy", "ppolicy"));
$mod->setAPIVersion("0:0:0");
$mod->setPriority(600);

/* Get the base module instance reference */
$base = &$MMCApp->getModule('base');
/* Get the computers sub-module instance reference */
$users = &$base->getSubmod('users');

/* Add the page to the module */
$page = new Page("ppolicy", _T("Default password policy", "ppolicy"));
$page->setFile("modules/ppolicy/default/ppolicy.php");
$users->addPage($page);

/* Declare variable to will can set hiden it */
$ppolicyattr = getPPolicyAttributesKeys();

foreach ($ppolicyattr as $key=>$info) {    // separate right between Global Password Policies Attributes from User PPolicy Attributes
    $mod->addACL('g'.$key, _T("Default ".$info[0],"ppolicy"));
}

$mod->addACL("ppolicyactivated", _T("Enable user specific password policy","ppolicy"));
foreach ($ppolicyattr as $key=>$info) {    // foreach the list of Supported Attributes
    $mod->addACL($key, _T($info[0],"ppolicy"));
}


$MMCApp =& MMCApp::getInstance();
$MMCApp->addModule($mod);

/* You should unset the references when you finished using them */
unset($base);
unset($users);
?>
